{{/*

    HTML/Canvas Rendering of BPMN Choreography-diagram
    
    Context: dict
       "name"           - diagram name
       "diagramSource"  - diagram source in BPMN/XML-format
       "height"         - Rendering height in pixels 
       "width"          - Rendering width in pixels

    Based on:
    - https://github.com/bptlab/chor-js
    - https://github.com/bpmn-io/bpmn-js-examples/tree/master/interaction

*/}}

{{ $defaultStyles := resources.GetRemote "https://cdn.jsdelivr.net/npm/chor-js@latest/dist/assets/chor-js.css" }}
{{ $chorJs := resources.GetRemote "https://cdn.jsdelivr.net/npm/chor-js@latest/dist/chor-js-modeler.min.js" }}
{{ $canvasId := urlize .name }}
{{ $bpmnUtils := resources.Get "js/bpmn-utils.js" }}

<link rel="stylesheet" href="{{ $defaultStyles.Permalink }}">
<script src="{{ $chorJs.Permalink }}"></script>
<script src="{{ $bpmnUtils.Permalink }}"></script>
<h2>{{ .name }}</h2>
<div id="{{ $canvasId }}"></div>
<script>
  const bpmnViewer = new ChorJS.NavigatedViewer({
    container: '#{{ $canvasId }}',
    height: {{ .height }},
    width: {{ .width }}
  });

  bpmnViewer.importXML('{{ .diagramSource }}');

  const eventBus = bpmnViewer.get('eventBus');
  eventBus.on('element.click', event => {
    const element = event.element;

    switch(element.type) {
      case 'bpmn:Message':
        businessObjectRouter(element.businessObject.name, '{{ site.BaseURL }}' + '/docs/berichten');
        break;
      case 'bpmn:ChoreographyTask':
        businessObjectRouter(element.businessObject.name, '{{ site.BaseURL }}' + '/docs/viewers/bpmn-js');
        break;
      default:
        console.log(element.type);
        console.log(element.businessObject.name);
    }
    
  });

</script>

{{ partial "bpmn/bpmn-msg-table" .diagramSource }}